class CAny {
 public:
    enum TAnyTyp {
        _UNDEF=0,
        _I,
        _R,
        _RD,
        _VI,
        _VR,
        _VRD
    } typ;
    int i;
    double r;
    double d;
    vector<int> vi;
    vector<double> vr;
    vector<double> vd;
    int nv;

    CAny( int _i ) : typ(_I), i(_i) {};
    CAny( double _r ) : typ(_R), r(_r) {};
    CAny( double _r, double _d ) : typ(_RD), r(_r), d(_d) {};
    CAny( const vector<int>& _vi ) : typ(_VI), vi(_vi), nv(_vi.size()) {};
    CAny( const vector<double>& _vr ) : typ(_VR), vr(_vr), nv(_vr.size()) {};
    CAny( const vector<double>& _vd )
        : typ(_VD), vr(_vr), vd(_vd), nv(_vr.size())
        { if ( _vd.size()!=nv )
                throw string( "BUG: CAny() with vr.size!=vd.size" ); };

    void clear();
    void push_i( int _i );
    void push_r( double _r );
    void push_rd( double _r, double _d );
    void remove( uint fro, uint to );

    int size() const;
};
